HDU 5816 Hearthstone(概率DP+状压)

Problem Description
Hearthstone is an online collectible card game from Blizzard Entertainment. Strategies and luck are the most important factors in this game. When you suffer a desperate situation and your only hope depends on the top of the card deck, and you draw the only card to solve this dilemma. We call this "Shen Chou Gou" in Chinese.

Now you are asked to calculate the probability to become a "Shen Chou Gou" to kill your enemy in this turn. To simplify this problem, we assume that there are only two kinds of cards, and you don't need to consider the cost of the cards.
-A-Card: If the card deck contains less than two cards, draw all the cards from the card deck; otherwise, draw two cards from the top of the card deck.
-B-Card: Deal X damage to your enemy.

Note that different B-Cards may have different X values.
At the beginning, you have no cards in your hands. Your enemy has P Hit Points (HP). The card deck has N A-Cards and M B-Cards. The card deck has been shuffled randomly. At the beginning of your turn, you draw a card from the top of the card deck. You can use all the cards in your hands until you run out of it. Your task is to calculate the probability that you can win in this turn, i.e., can deal at least P damage to your enemy.




Input
The first line is the number of test cases T (T<=10).
Then come three positive integers P (P<=1000), N and M (N+M<=20), representing the enemy’s HP, the number of A-Cards and the number of B-Cards in the card deck, respectively. Next line come M integers representing X (0<X<=1000) values for the B-Cards.


Output
For each test case, output the probability as a reduced fraction (i.e., the greatest common divisor of the numerator and denominator is 1). If the answer is zero (one), you should output 0/1 (1/1) instead.


Sample Input
2
3 1 2
1 2
3 5 10
1 1 1 1 1 1 1 1 1 1


Sample Output
1/3

46/273


题意:BOSS有P点血。一共有N张A牌,和M张B牌。A牌可以再抽两张,第i张B牌可以对BOSS造成Xi点伤害。第一次可以抽一张,问获胜概率。


思路:先预处理出当拥有K张B牌是获胜的概率,设dp[i][j]表示拥有i张A牌和j张B牌的概率。j<=i+1为合法情况。

抽出1张A牌,1张B牌的概率dp[i-1][j-1]*(n-i+1)*(m-j+1)/C(2, n+m-i-j+2);

抽出2张A牌的概率dp[i-2][j]*C(2, n-i+2)/C(2, n+m-i-j+2);

抽出2张B牌的概率dp[i][j-2]*C(2, m-j+2)/C(2, n+m-i-j+2);


几个要注意的地方:

1. 全场要用long long

2. if(i==n&&j==m&&(n+m)%2==0)  表示此时仅剩下一张B牌可抽,所以要算上dp[i][j-1]

3. 如果j张B牌获胜的概率为1了,就不会再继续抽牌了


#include <iostream>
#include <stdio.h>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <cstdlib>
#include <string.h>
#include <vector>
#include <queue>
#include <stack>
#include <ctype.h>
using namespace std;

typedef long long ll;

ll gcd(ll a,ll b)
{
    if(b == 0)
    {
        return a;
    }
    return gcd(b,a%b);
}

struct node    //分数结构体
{
    ll up,down;
    void init(ll x,ll y)
    {
        up = x;   //分子
        down = y;   //分母
    }
    
    node operator+ (node n2)
    {
        built();
        n2.built();
        ll x = down * n2.down;
        ll y = up * n2.down + down*n2.up;
        ll d = gcd(x,y);
        x/=d;
        y/=d;
        node n3;
        n3.init(y,x);
        return n3;
    }
    
    node operator- (node n2)
    {
        built();
        n2.built();
        ll x = down *n2.down;
        ll y = up * n2.down - down*n2.up;
        ll d = gcd(x,y);
        x/=d;
        y/=d;
        node n3;
        n3.init(y,x);
        return n3;
    }
    
    node operator*(node n2)
    {
        built();
        n2.built();
        ll x = down * n2.down;
        ll y = up*n2.up;
        ll d = gcd(x,y);
        x/=d;
        y/=d;
        node n3;
        n3.init(y,x);
        return n3;
    }
    void built()
    {
        if(down<0)
        {
            down = -down;
            up = -up;
        }
        if(up==0)
        {
            down=1;
        }
    }
    void shownode()
    {
        cout<<up<<"/"<<down<<endl;
    }
};

node dp[25][25];
ll a[25];
node win[25];

ll CAL(ll x)   //组合数
{
    return x*(x-1)/2;
}

int main()
{
    int t;
    cin>>t;
    while(t--)
    {
        ll p,n,m;
        scanf("%lld%lld%lld",&p,&n,&m);
        for(int i=0;i<m;i++)
        {
            scanf("%lld",&a[i]);
            win[i].up=0;
            win[i].down=0;
        }
        win[m].up=0;
        win[m].down=0;
        ll mmm=1<<m;
        for(int i=0;i<mmm;i++)
        {
            ll res=i;
            ll cnt=0;
            ll cnt1=0;
            ll sum=0;
            while(res>0)
            {
                ll xxx=res%2;
                if(xxx==1)
                {
                    cnt1++;
                    sum+=a[cnt];
                }
                res/=2;
                cnt++;
            }
            if(sum>=p) win[cnt1].up++;
            win[cnt1].down++;
        }
        node ans;
        ans.init(0,1);
        for(int i=0;i<=n;i++)
        {
            for(int j=0;j<=m;j++)
            {
                dp[i][j].init(0,1);
            }
        }
        dp[1][0].init(n,n+m);
        dp[0][1].init(m,n+m);
        ans=ans+dp[0][1]*win[1];
        for(int i=1;i<=n;i++)
        {
            for(int j=0;j<=i+1&&j<=m;j++)
            {
                if(j>=1&&i>=j)
                {
                    node xx;
                    xx.up=(n-i+1)*(m-j+1);
                    xx.down=CAL(n+m-i-j+2);
                    dp[i][j]=dp[i][j]+dp[i-1][j-1]*xx;
                }
                if(i>=2&&i-2>=j)
                {
                    if(!(win[j].up==1&&win[j].down==1))
                    {
                        node xx;
                        xx.up=CAL(n-i+2);
                        xx.down=CAL(n+m-i-j+2);
                        dp[i][j]=dp[i][j]+dp[i-2][j]*xx;
                    }
                }
                if(j>=2&&i>=j-2)
                {
                    node xx;
                    xx.up=CAL(m-j+2);
                    xx.down=CAL(n+m-i-j+2);
                    dp[i][j]=dp[i][j]+dp[i][j-2]*xx;
                }
                if(i==n&&j==m&&(n+m)%2==0)
                {
                    if(i>=j-1) dp[i][j]=dp[i][j]+dp[i][j-1];
                }
                if(i+1==j||j==m)
                {
                    ans=ans+dp[i][j]*win[j];
                }
            }
        }
        ans.shownode();
    }
    return 0;
}

/*
 10
 41 7 13
 334 500 169 724 478 358 962 464 705 145 281 827 961
 491 15 5
 942 827 436 391 604
 902 13 7
 292 382 421 716 718 895 447
 726 11 9
 538 869 912 667 299 35 894 703 811
 322 13 7
 673 664 141 711 253 868 547
 644 2 18
 757 37 859 723 741 529 778 316 35 190 842 288 106 40 942 264 648 446
 805 10 10
 729 370 350 6 101 393 548 629 623 84
 954 16 4
 840 966 376 931
 308 4 16
 439 626 323 537 538 118 82 929 541 833 115 639 658 704 930 977
 306 13 7
 386 21 745 924 72 270 829
 */
/*
 1/1
 9/10
 143/228
 211/285
 9/10
 111077/232560
 134735/325584
 17/20
 193/228
 2881/3420
*/

最后是数据,可供参考。

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
### 回答1: hdu 2829 Lawrence 斜率优化dp 这道题是一道经典的斜率优化dp题目,需要用到单调队列的思想。 题目大意是给定一个序列a,求出一个序列b,使得b[i]表示a[1]~a[i]中的最小值,且满足b[i] = min{b[j] + (i-j)*k},其中k为给定的常数。 我们可以将上式拆开,得到b[i] = min{b[j] - j*k} + i*k,即b[i] = i*k + min{b[j] - j*k},这个式子就是斜率优化dp的形式。 我们可以用单调队列来维护min{b[j] - j*k},具体思路如下: 1. 首先将第一个元素加入队列中。 2. 从第二个元素开始,我们需要将当前元素加入队列中,并且需要维护队列的单调性。 3. 维护单调性的方法是,我们从队列的末尾开始,将队列中所有大于当前元素的元素弹出,直到队列为空或者队列中最后一个元素小于当前元素为止。 4. 弹出元素的同时,我们需要计算它们对应的斜率,即(b[j]-j*k)/(j-i),并将这些斜率与当前元素的斜率比较,如果当前元素的斜率更小,则将当前元素加入队列中。 5. 最后队列中的第一个元素就是min{b[j] - j*k},我们将它加上i*k就得到了b[i]的值。 6. 重复以上步骤直到处理完所有元素。 具体实现可以参考下面的代码: ### 回答2: HDU 2829 Lawrence 斜率优化 DP 是一道经典的斜率优化 DP 题目,其思想是通过维护一个下凸包来优化 DP 算法。下面我们来具体分析一下这道题目。 首先,让我们看一下该题目的描述。题目给定一些木棒,要求我们将这些木棒割成一些给定长度,且要求每种长度的木棒的数量都是一样的,求最小的割枝次数。这是一个典型的背包问题,而且在此基础上还要求每种长度的木棒的数量相同,这就需要我们在状态设计上走一些弯路。 我们来看一下状态的定义。定义 $dp[i][j]$ 表示前 $i$ 个木棒中正好能割出 $j$ 根长度为 $c_i$ 的木棒的最小割枝次数。对于每个 $dp[i][j]$,我们可以分类讨论: 1. 不选当前的木棒,即 $dp[i][j]=dp[i-1][j]$; 2. 选当前的木棒,即 $dp[i][j-k]=dp[i-1][j-k]+k$,其中 $k$ 是 $j/c_i$ 的整数部分。 现在问题再次转化为我们需要在满足等量限制的情况下,求最小的割枝次数。可以看出,这是一个依赖于 $c_i$ 的限制。于是,我们可以通过斜率优化 DP 来解决这个问题。 我们来具体分析一下斜率优化 DP 算法的思路。我们首先来看一下动态规划的状态转移方程 $dp[i][j]=\min\{dp[i-1][k]+x_k(i,j)\}$。可以发现,$dp[i][j]$ 的最小值只与 $dp[i-1][k]$ 和 $x_k(i,j)$ 有关。其中,$x_k(i,j)$ 表示斜率,其值为 $dp[i-1][k]-k\times c_i+j\times c_i$。 接下来,我们需要维护一个下凸包,并通过斜率进行优化。我们具体分析一下该过程。假设我们当前要计算 $dp[i][j]$。首先,我们需要找到当前点 $(i,j)$ 在凸包上的位置,即斜率最小值的位置。然后,我们根据该位置的斜率计算 $dp[i][j]$ 的值。接下来,我们需要将当前点 $(i,j)$ 加入到下凸包上。 我们在加入点的时候需要注意几点。首先,我们需要将凸包中所有斜率比当前点小的点移除,直到该点能够加入到凸包中为止。其次,我们需要判断该点是否能够加入到凸包中。如果不能加入到凸包中,则直接舍弃。最后,我们需要保证凸包中斜率是单调递增的,这就需要在加入新的点之后进行上一步操作。 以上就是该题目的解题思路。需要注意的是,斜率优化 DP 算法并不是万能的,其使用情况需要根据具体的问题情况来确定。同时,该算法中需要维护一个下凸包,可能会增加一些算法的复杂度,建议和常规 DP 算法进行对比,选择最优的算法进行解题。 ### 回答3: 斜率优化DP是一种动态规划优化算法,其主要思路是通过对状态转移方程进行变形,提高算法的时间复杂度。HDU2829 Lawrence问题可以用斜率优化DP解决。 首先,我们需要了解原问题的含义。问题描述如下:有$n$个人在数轴上,第$i$个人的位置为$A_i$,每个人可以携带一定大小的行李,第$i$个人的行李重量为$B_i$,但是每个人只能帮助没有他们重量大的人搬行李。若第$i$个人搬运了第$j$个人的行李,那么第$i$个人会累加$C_{i,j}=\left|A_i-A_j\right|\cdot B_j$的体力消耗。求$m$个人帮助每个人搬运行李的最小体力消耗。 我们可以通过斜率优化DP解决这个问题。记$f_i$为到前$i$个人的最小体力消耗,那么状态转移方程为: $$f_i=\min_{j<i}\{f_j+abs(A_i-A_j)\cdot B_i\}$$ 如果直接使用该方程,时间复杂度为$O(n^2)$,如果$n=10^4$,则需要计算$10^8$次,运算时间极长。斜率优化DP通过一些数学推导将方程变形,将时间复杂度降低到$O(n)$,大大缩短了计算时间。 通过斜率优化DP的推导式子,我们可以得到转移方程为: $$f_i=\min_{j<i}\{f_j+slope(j,i)\}$$ 其中,$slope(j,i)$表示直线$j-i$的斜率。我们可以通过如下方式来求解$slope(j,i)$: $$slope(j,i)=\frac{f_i-f_j}{A_i-A_j}-B_i-B_j$$ 如果$slope(j,i)\leq slope(j,k)$,那么$j$一定不是最优,可以直接舍去,降低计算时间。该算法的时间复杂度为$O(n)$。 综上所述,斜率优化DP是一种动态规划优化算法,可以大大缩短计算时间。在处理类似HDU2829 Lawrence问题的时候,斜率优化DP可以很好地解决问题。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值